﻿using System;
using Telerik.Windows.Cloud;

namespace wpf_CloudUpload_1001754
{
    public class CustomProvider : ICloudUploadProvider
    {
        public event EventHandler<CUFUploadedEventArgs> CUFUploaded;

        public System.Threading.Tasks.Task<object> UploadFileAsync(string fileName, System.IO.Stream fileStream, CloudUploadFileProgressChanged uploadProgressChanged, System.Threading.CancellationToken cancellationToken)
        {
            Func<object> action = () =>
            {
                // upload file here
                CustomFileResult customFileResult = new CustomFileResult();

                // raise event here
                this.RaiseCUFUploaded(customFileResult);

                return customFileResult;
            };

            return System.Threading.Tasks.Task.Factory.StartNew<object>(action);
        }

        private void RaiseCUFUploaded(CustomFileResult customFileResult)
        {
            var handler = this.CUFUploaded;
            if (handler != null)
            {
                handler(this, new CUFUploadedEventArgs(customFileResult));
            }
        }
    }
}